"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Maps = require('./Maps');

var _Maps2 = _interopRequireDefault(_Maps);

var _CommonProps = require('./CommonProps');

var _CommonProps2 = _interopRequireDefault(_CommonProps);

var _Shoot = require('./Shoot');

var _Shoot2 = _interopRequireDefault(_Shoot);

var _Container = require('./core/Container');

var _Container2 = _interopRequireDefault(_Container);

var _Projection = require('./core/Projection');

var _GeoPath = require('./core/GeoPath');

var _ZoomControl = require('./core/ZoomControl');

var _ZoomControl2 = _interopRequireDefault(_ZoomControl);

var _FormatHelper = require('./utils/FormatHelper');

var _Popup = require('./core/Popup');

var _Popup2 = _interopRequireDefault(_Popup);

var _immutable = require('immutable');

var _china = require('../data/china');

var _china2 = _interopRequireDefault(_china);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MapContainer = function (_Component) {
  _inherits(MapContainer, _Component);

  function MapContainer(props) {
    _classCallCheck(this, MapContainer);

    var _this = _possibleConstructorReturn(this, (MapContainer.__proto__ || Object.getPrototypeOf(MapContainer)).call(this, props));

    _this.state = {
      mapName: (0, _FormatHelper.formatName)(props.mapName, props.mapName),
      // 移动
      zoomTranslate: null,
      // 比例尺-缩放
      scale: null,
      // 缩放频率
      times: 1,
      finish: false,
      showPopup: (0, _immutable.OrderedMap)(),
      chinaGeoData: null,
      worldGeoData: null
    };
    return _this;
  }

  _createClass(MapContainer, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var mapName = this.state.mapName;


      if (_china2.default.provinceIndex[mapName]) {
        this.setState({
          scale: this.props.width * _china2.default.provinceIndex[mapName].scale / 600
        });
      } else {
        this.setState({
          scale: null
        });
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.getRequestGeoData(this.props.geoDataUrl, this.props.mapName);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.mapName !== this.props.mapName) {
        var newMapName = (0, _FormatHelper.formatName)(nextProps.mapName, nextProps.mapName);

        if (_china2.default.provinceIndex[newMapName]) {
          this.setState({
            mapName: newMapName,
            scale: this.props.width * _china2.default.provinceIndex[newMapName].scale / 600
          });
        } else {
          this.setState({
            mapName: '',
            scale: null
          });
        }

        this.getRequestGeoData(nextProps.geoDataUrl, nextProps.mapName);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      // 彻底销毁，防止内存泄漏

      if (this.chinaGeoData) {
        document.body.removeChild(this.chinaGeoData);
        this.chinaGeoData = null;
      }

      if (this.worldGeoData) {
        document.body.removeChild(this.worldGeoData);
        this.worldGeoData = null;
      }
    }
  }, {
    key: 'getRequestGeoData',
    value: function getRequestGeoData(geoDataUrl, mapName) {
      var _this2 = this;

      var chinaUrl = 'https://unpkg.com/china-map-geojson@1.0.4/umd/china-map-geojson.min.js';
      var worldUrl = 'https://unpkg.com/world-map-geojson@1.0.2/umd/world-map-geojson.min.js';

      if (geoDataUrl) {
        if (typeof geoDataUrl === 'string') {
          chinaUrl = geoDataUrl;
        }
        if ((typeof geoDataUrl === 'undefined' ? 'undefined' : _typeof(geoDataUrl)) === 'object') {
          chinaUrl = geoDataUrl.china ? geoDataUrl.china : chinaUrl;
          worldUrl = geoDataUrl.world ? geoDataUrl.world : worldUrl;
        }
      }

      if (!this.chinaGeoData && mapName !== '世界') {
        this.chinaGeoData = document.createElement('script');
        this.chinaGeoData.type = 'text/javascript';
        this.chinaGeoData.async = true;
        this.chinaGeoData.src = chinaUrl;
        this.chinaGeoData.onload = function () {
          _this2.setState({
            chinaGeoData: window["china-map-geojson"]
          });
        };
        document.body.appendChild(this.chinaGeoData);
      }

      if (!this.worldGeoData && mapName === '世界') {
        this.worldGeoData = document.createElement('script');
        this.worldGeoData.type = 'text/javascript';
        this.worldGeoData.async = true;
        this.worldGeoData.src = worldUrl;
        this.worldGeoData.onload = function () {
          _this2.setState({
            worldGeoData: window["world-map-geojson"]
          });
        };
        document.body.appendChild(this.worldGeoData);
      }
    }
  }, {
    key: 'onZoom',
    value: function onZoom(zoomScale, zoomTranslate) {
      var times = this.state.times;

      this.setState({
        scale: zoomScale * times,
        zoomTranslate: zoomTranslate
      });
    }
  }, {
    key: 'zoomIn',
    value: function zoomIn() {
      var times = this.state.times;

      this.setState({
        times: times * 2,
        scale: this.state.scale * 2
      });
    }
  }, {
    key: 'zoomOut',
    value: function zoomOut() {
      var times = this.state.times;

      this.setState({
        times: times / 2,
        scale: this.state.scale / 2
      });
    }
  }, {
    key: 'handleFinish',
    value: function handleFinish(finish) {
      this.setState({
        finish: finish
      });
    }
  }, {
    key: 'getOffset',
    value: function getOffset(el) {
      var box = el.getBoundingClientRect();

      return {
        top: box.top + window.pageYOffset - document.documentElement.clientTop,
        left: box.left + window.pageXOffset - document.documentElement.clientLeft
      };
    }
  }, {
    key: 'getCurrentData',
    value: function getCurrentData(data) {
      var mapName = this.state.mapName;
      var _props = this.props,
          extData = _props.extData,
          nameKey = _props.nameKey;


      var currentData = void 0;

      extData.forEach(function (item) {
        var tempName = (0, _FormatHelper.formatName)(item[nameKey], mapName);

        if (tempName === (0, _FormatHelper.formatName)(data.properties.name, mapName)) {
          currentData = item;
        }
      });

      return currentData;
    }
  }, {
    key: '_onClick',
    value: function _onClick(that, data, id, e) {
      var _props2 = this.props,
          extData = _props2.extData,
          nameKey = _props2.nameKey,
          onClick = _props2.onClick;


      if (onClick) {
        var currentData = this.getCurrentData(data);
        onClick(currentData, data.properties, e);
      }
    }
  }, {
    key: '_onMouseOver',
    value: function _onMouseOver(that, d, id, e) {
      var showPopup = this.state.showPopup;
      var onMouseOver = this.props.onMouseOver;


      if (onMouseOver) {
        var currentData = this.getCurrentData(d);
        onMouseOver(currentData, d.properties, e);
      }

      var mapContainer = this.refs.mapContainer;

      var xy = [e.pageX - this.getOffset(mapContainer).left, e.pageY - this.getOffset(mapContainer).top];

      var position = this.projection.invert([xy[0], xy[1]]);

      var newPopup = showPopup.set(id, (0, _immutable.Map)({
        xPopup: position[0],
        yPopup: position[1],
        data: d
      }));

      this.setState({
        showPopup: newPopup
      });
    }
  }, {
    key: '_onMouseMove',
    value: function _onMouseMove(that, d, id, e) {
      var showPopup = this.state.showPopup;
      var onMouseMove = this.props.onMouseMove;


      if (onMouseMove) {
        var currentData = this.getCurrentData(d);
        onMouseMove(currentData, d.properties, e);
      }

      var mapContainer = this.refs.mapContainer;

      var xy = [e.pageX - this.getOffset(mapContainer).left, e.pageY - this.getOffset(mapContainer).top];

      var position = this.projection.invert([xy[0], xy[1]]);

      var newPopup = showPopup.set(id, (0, _immutable.Map)({
        xPopup: position[0],
        yPopup: position[1],
        data: d
      }));

      this.setState({
        showPopup: newPopup
      });
    }
  }, {
    key: '_onMouseOut',
    value: function _onMouseOut(that, d, id, e) {
      var showPopup = this.state.showPopup;
      var onMouseOut = this.props.onMouseOut;


      if (onMouseOut) {
        var currentData = this.getCurrentData(d);
        onMouseOut(currentData, d.properties, e);
      }

      var newPopup = showPopup.delete(id);

      this.setState({
        showPopup: newPopup
      });
    }
  }, {
    key: 'getGeoData',
    value: function getGeoData(mapName) {
      var geoData = void 0;

      if (this.props.geoData) {
        if (mapName === '世界') {
          geoData = this.props.geoData;
        } else if (mapName === '中国') {
          geoData = this.props.geoData;
        } else {
          var provinceName = (0, _FormatHelper.formatProvinceName)(mapName);
          geoData = provinceName ? this.props.geoData[provinceName] : null;
        }
      } else {
        if (mapName === '世界') {
          geoData = this.state.worldGeoData;
        } else if (mapName === '中国') {
          geoData = this.state.chinaGeoData && this.state.chinaGeoData.ChinaData;
        } else {
          var _provinceName = (0, _FormatHelper.formatProvinceName)(mapName);
          geoData = this.state.chinaGeoData && this.state.chinaGeoData.ProvinceData;
          geoData = _provinceName ? (geoData || {})[_provinceName] : null;
        }
      }

      return geoData;
    }
  }, {
    key: 'render',
    value: function render() {
      var _state = this.state,
          mapName = _state.mapName,
          scale = _state.scale,
          zoomTranslate = _state.zoomTranslate,
          finish = _state.finish,
          showPopup = _state.showPopup;
      var _props3 = this.props,
          className = _props3.className,
          width = _props3.width,
          zoom = _props3.zoom,
          projection = _props3.projection,
          simplify = _props3.simplify,
          simplifyArea = _props3.simplifyArea,
          clip = _props3.clip,
          bounds = _props3.bounds,
          data = _props3.data,
          shootData = _props3.shootData,
          hasShootLoop = _props3.hasShootLoop,
          shootDuration = _props3.shootDuration,
          extData = _props3.extData,
          nameKey = _props3.nameKey,
          valueKey = _props3.valueKey,
          colorArr = _props3.colorArr,
          defaultColor = _props3.defaultColor,
          shootColor = _props3.shootColor,
          hoverColor = _props3.hoverColor,
          hasLegend = _props3.hasLegend,
          legendPos = _props3.legendPos,
          hasName = _props3.hasName,
          popupContent = _props3.popupContent,
          sortableColor = _props3.sortableColor;


      var center = _china2.default.provinceIndex[mapName].center;

      var popup = void 0,
          geoData = void 0;
      var height = width * 3 / 4;
      var styleContainer = {
        position: 'relative',
        width: width,
        height: height
      };
      var styleWarning = {
        position: 'absolute',
        top: height / 2 - 25,
        left: width / 2 - 150
      };

      if (!scale) {
        return _react2.default.createElement(
          'div',
          { ref: 'mapContainer', className: className, style: styleContainer },
          _react2.default.createElement(
            'p',
            { className: 'Warning', style: styleWarning },
            '\u76EE\u524D\u6682\u53EA\u652F\u6301\u4E2D\u56FD\u4EE5\u53CA\u4E2D\u56FD\u5404\u7701\u4EFD\u7684\u5730\u56FE\uFF01'
          )
        );
      }

      var onZoom = this.onZoom.bind(this);
      var zoomIn = this.zoomIn.bind(this);
      var zoomOut = this.zoomOut.bind(this);
      var handleFinish = this.handleFinish.bind(this);
      var onMouseOver = this._onMouseOver.bind(this);
      var onMouseMove = this._onMouseMove.bind(this);
      var onMouseOut = this._onMouseOut.bind(this);
      var onClick = this._onClick.bind(this);

      // 初始地图位置
      var translate = [width / 2, height / 2] || this.props.translate;

      var proj = (0, _Projection.Projection)({
        projection: projection,
        scale: scale / 2 / Math.PI,
        translate: zoomTranslate || translate,
        center: center,
        simplify: simplify,
        simplifyArea: simplifyArea,
        clip: clip,
        bounds: bounds
      });

      geoData = this.getGeoData(mapName);

      var geo = (0, _GeoPath.GeoPath)(proj);

      this.projection = proj;

      if (showPopup.size && popupContent) {
        popup = showPopup.keySeq().toArray().map(function (d, i) {
          var xPopup = showPopup.get(d).get('xPopup');
          var yPopup = showPopup.get(d).get('yPopup');
          var popupData = showPopup.get(d).get('data');

          var point = proj([xPopup, yPopup]);

          var currentData = void 0;

          extData.forEach(function (item) {
            var tempName = (0, _FormatHelper.formatName)(item[nameKey], mapName);

            if (tempName === (0, _FormatHelper.formatName)(popupData.properties.name, mapName)) {
              currentData = item;
            }
          });

          var content = popupContent(currentData);

          if (content) {
            return _react2.default.createElement(_Popup2.default, {
              key: 'Popup' + i,
              x: point[0],
              y: point[1],
              contentPopup: content
            });
          }
        });
      }

      return _react2.default.createElement(
        'div',
        { ref: 'mapContainer', className: className, style: styleContainer },
        _react2.default.createElement(
          _Container2.default,
          _extends({}, this.props, {
            width: width,
            height: height,
            projection: proj,
            onZoom: zoom ? onZoom : null,
            center: center
          }),
          _react2.default.createElement(_Maps2.default, {
            width: width,
            height: height,
            data: extData,
            nameKey: nameKey,
            valueKey: valueKey,
            colorArr: colorArr,
            defaultColor: defaultColor,
            shootColor: shootColor,
            hoverColor: hoverColor,
            hasLegend: hasLegend,
            legendPos: legendPos,
            hasName: hasName,
            popupContent: popupContent,
            finish: finish,
            shootData: shootData || [],
            mapName: mapName,
            geoPath: geo,
            geoData: geoData,
            projection: proj,
            onMouseOver: onMouseOver,
            onMouseMove: onMouseMove,
            onMouseOut: onMouseOut,
            onClick: onClick,
            sortableColor: sortableColor,
            zoom: zoom
          })
        ),
        zoom ? _react2.default.createElement(_ZoomControl2.default, {
          zoomInClick: zoomIn,
          zoomOutClick: zoomOut
        }) : null,
        shootData ? _react2.default.createElement(_Shoot2.default, {
          width: width,
          height: height,
          mapName: mapName,
          shootData: shootData,
          hasShootLoop: hasShootLoop,
          shootDuration: shootDuration,
          projection: proj,
          shootFinish: handleFinish,
          ChinaGeoOpt: _china2.default
        }) : null,
        popup
      );
    }
  }]);

  return MapContainer;
}(_react.Component);

MapContainer.defaultProps = {
  width: 600,
  projection: 'mercator',
  mapName: '',
  simplify: true,
  simplifyArea: 0,
  hasShootLoop: false,
  nameKey: 'name',
  valueKey: 'value',
  hasName: false,
  hasLegend: false,
  shootColor: '#FCE687',
  hoverColor: '#86C899',
  // 是否严格按照颜色排序
  sortableColor: false
};
exports.default = MapContainer;