"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _PolygonSet = require('./PolygonSet');

var _PolygonSet2 = _interopRequireDefault(_PolygonSet);

var _TextSet = require('./TextSet');

var _TextSet2 = _interopRequireDefault(_TextSet);

var _SouthSea = require('./core/SouthSea');

var _SouthSea2 = _interopRequireDefault(_SouthSea);

var _Taiwan = require('./core/Taiwan');

var _Taiwan2 = _interopRequireDefault(_Taiwan);

var _Legend = require('./core/Legend');

var _Legend2 = _interopRequireDefault(_Legend);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Maps = function (_Component) {
  _inherits(Maps, _Component);

  function Maps(props) {
    _classCallCheck(this, Maps);

    return _possibleConstructorReturn(this, (Maps.__proto__ || Object.getPrototypeOf(Maps)).call(this, props));
  }

  _createClass(Maps, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          data = _props.data,
          nameKey = _props.nameKey,
          valueKey = _props.valueKey,
          defaultColor = _props.defaultColor,
          hoverColor = _props.hoverColor,
          colorArr = _props.colorArr,
          shootColor = _props.shootColor,
          type = _props.type,
          hasLegend = _props.hasLegend,
          legendPos = _props.legendPos,
          hasName = _props.hasName,
          popupContent = _props.popupContent,
          zoom = _props.zoom,
          width = _props.width,
          height = _props.height,
          finish = _props.finish,
          shootData = _props.shootData,
          mapName = _props.mapName,
          geoPath = _props.geoPath,
          geoData = _props.geoData,
          projection = _props.projection,
          onMouseOver = _props.onMouseOver,
          onMouseMove = _props.onMouseMove,
          onMouseOut = _props.onMouseOut,
          onClick = _props.onClick,
          sortableColor = _props.sortableColor;


      if (!geoData) {
        return null;
      }

      return _react2.default.createElement(
        'g',
        { className: 'Maps' },
        _react2.default.createElement(_PolygonSet2.default, _extends({
          className: 'PolygonSet',
          mapName: mapName,
          data: data ? data : [],
          nameKey: nameKey,
          valueKey: valueKey,
          shootData: shootData,
          shootFinish: finish,
          defaultColor: defaultColor,
          hoverColor: hoverColor,
          shootColor: shootColor,
          colorArr: colorArr,
          projection: projection,
          geoData: geoData,
          geoPath: geoPath,
          onMouseOver: onMouseOver,
          onMouseMove: onMouseMove,
          onMouseOut: onMouseOut,
          onClick: onClick,
          sortableColor: sortableColor
        }, this.state)),
        hasLegend ? _react2.default.createElement(_Legend2.default, { width: width,
          height: height,
          defaultColor: defaultColor,
          colorArr: colorArr,
          legendPos: legendPos }) : null,

        // 台湾诸岛，钓鱼岛和赤尾屿，且在无法缩放时才展示，如果地图有缩放功能时，可以通过放大查看
        mapName === '中国' && !zoom ? _react2.default.createElement(_Taiwan2.default, { width: width, height: height, defaultColor: defaultColor }) : null,

        // 南海诸岛
        mapName === '中国' ? _react2.default.createElement(_SouthSea2.default, { width: width, height: height, defaultColor: defaultColor }) : null,
        hasName ? _react2.default.createElement(_TextSet2.default, _extends({
          className: 'TextSet',
          projection: projection,
          geoData: geoData
        }, this.state)) : null
      );
    }
  }]);

  return Maps;
}(_react.Component);

Maps.propTypes = {};
exports.default = Maps;