"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Polygon = require('./core/Polygon');

var _Polygon2 = _interopRequireDefault(_Polygon);

var _FormatHelper = require('./utils/FormatHelper');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PolygonSet = function (_Component) {
  _inherits(PolygonSet, _Component);

  function PolygonSet(props) {
    _classCallCheck(this, PolygonSet);

    return _possibleConstructorReturn(this, (PolygonSet.__proto__ || Object.getPrototypeOf(PolygonSet)).call(this, props));
  }

  _createClass(PolygonSet, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          mapName = _props.mapName,
          data = _props.data,
          nameKey = _props.nameKey,
          valueKey = _props.valueKey,
          defaultColor = _props.defaultColor,
          hoverColor = _props.hoverColor,
          shootColor = _props.shootColor,
          colorArr = _props.colorArr,
          geoData = _props.geoData,
          geoPath = _props.geoPath,
          projection = _props.projection,
          onClick = _props.onClick,
          onMouseOver = _props.onMouseOver,
          onMouseMove = _props.onMouseMove,
          onMouseOut = _props.onMouseOut,
          shootFinish = _props.shootFinish,
          shootData = _props.shootData,
          sortableColor = _props.sortableColor;


      var tempDataArr = [];
      var polygons = void 0,
          polygonData = void 0,
          maxData = void 0,
          minData = void 0,
          color = void 0,
          temp = void 0;
      var hasDefaultColor = void 0;

      if (geoData.type === 'FeatureCollection') {
        polygonData = [];

        // 遍历 features
        geoData.features.forEach(function (d) {
          polygonData.push(d);
        });
      } else if (geoData.type === 'Feature') {
        polygonData = geoData;
      }

      if (polygonData) {
        // 如果不是数组，将其转换成数组
        if (!Array.isArray(polygonData)) polygonData = [polygonData];

        if (data.length > 0) {
          maxData = polygonData.map(function (d, i) {
            data.forEach(function (item) {
              var tempName = (0, _FormatHelper.formatName)(item[nameKey], mapName);

              if (tempName === (0, _FormatHelper.formatName)(d.properties.name, mapName)) {
                tempDataArr.push(item[valueKey]);
              }
            });

            return tempDataArr;
          });

          maxData = Math.max.apply(null, tempDataArr);
          minData = Math.min.apply(null, tempDataArr);
        }

        polygons = polygonData.map(function (d, i) {
          var oldColor = void 0;

          hasDefaultColor = true;

          if (data.length > 0) {
            data.map(function (item, dataIndex) {
              var name = (0, _FormatHelper.formatName)(item[nameKey], mapName);

              if (name === (0, _FormatHelper.formatName)(d.properties.name, mapName)) {
                hasDefaultColor = false;
                temp = Math.floor((colorArr.length - 1) * (item[valueKey] - minData) / (maxData - minData));

                if (sortableColor) {
                  color = colorArr[dataIndex] || defaultColor;
                } else {
                  color = colorArr[temp];
                }

                if (maxData === minData) color = colorArr[0];

                if (item[valueKey] <= 0) color = defaultColor;
              }
            });
          }

          if (!color) {
            color = defaultColor;
          }

          if (hasDefaultColor) {
            color = defaultColor;
          }

          oldColor = color;

          if (shootFinish) {
            color = oldColor;
          } else {
            for (var _i = 0; _i < shootData.length; _i++) {
              if ((0, _FormatHelper.formatName)(d.properties.name, mapName) === (0, _FormatHelper.formatName)(shootData[_i].from, mapName) || (0, _FormatHelper.formatName)(d.properties.name, mapName) === (0, _FormatHelper.formatName)(shootData[_i].to, mapName)) {
                color = shootColor;
              }
            }
          }

          return _react2.default.createElement(_Polygon2.default, {
            key: 'remaps_polygon' + i,
            color: color,
            hasDefaultColor: hasDefaultColor,
            hoverColor: hoverColor,
            projection: projection,
            geoData: d,
            geoPath: geoPath,
            onClick: onClick,
            onMouseOver: onMouseOver,
            onMouseMove: onMouseMove,
            onMouseOut: onMouseOut
          });
        });
      }

      return _react2.default.createElement(
        'g',
        null,
        polygons
      );
    }
  }]);

  return PolygonSet;
}(_react.Component);

exports.default = PolygonSet;