"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Legend = function (_Component) {
  _inherits(Legend, _Component);

  function Legend(props) {
    _classCallCheck(this, Legend);

    return _possibleConstructorReturn(this, (Legend.__proto__ || Object.getPrototypeOf(Legend)).call(this, props));
  }

  _createClass(Legend, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          width = _props.width,
          height = _props.height,
          colorArr = _props.colorArr,
          defaultColor = _props.defaultColor,
          legendPos = _props.legendPos;


      var legendWidth = void 0,
          legendX = void 0,
          legendY = void 0;

      if (legendPos) {
        legendX = legendPos[0];
        legendY = legendPos[1];
      } else {
        legendX = 50;
        legendY = 50;
      }

      var legends = colorArr.map(function (d, i) {
        legendWidth = i * 20;

        return _react2.default.createElement('rect', { key: 'legend' + i, width: '20', height: '15', fill: d,
          transform: "translate(" + (legendX + i * 20) + "," + (height - legendY) + ")" });
      });

      return _react2.default.createElement(
        'g',
        { clsssName: 'legends' },
        _react2.default.createElement(
          'text',
          { fill: defaultColor, transform: "translate(" + (legendX - 25) + "," + (height - legendY + 12) + ")" },
          '\u4F4E'
        ),
        legends,
        _react2.default.createElement(
          'text',
          { fill: defaultColor, transform: "translate(" + (legendX + 25 + legendWidth) + "," + (height - legendY + 12) + ")" },
          '\u9AD8'
        )
      );
    }
  }]);

  return Legend;
}(_react.Component);

Legend.propTypes = {
  width: _react.PropTypes.number,
  height: _react.PropTypes.number,
  defaultColor: _react.PropTypes.string,
  colorArr: _react.PropTypes.array,
  legendPos: _react.PropTypes.array
};
exports.default = Legend;