"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Popup = require('./Popup');

var _Popup2 = _interopRequireDefault(_Popup);

var _TooltipUpdate = require('./TooltipUpdate');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Polygon = function (_Component) {
  _inherits(Polygon, _Component);

  function Polygon(props) {
    _classCallCheck(this, Polygon);

    var _this = _possibleConstructorReturn(this, (Polygon.__proto__ || Object.getPrototypeOf(Polygon)).call(this, props));

    _this.state = {
      fill: _this.props.color
    };
    return _this;
  }

  _createClass(Polygon, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !(0, _TooltipUpdate.isTooltipUpdate)(nextProps, nextState, this);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.color !== this.props.color) {
        this.setState({
          fill: nextProps.color
        });
      }
    }

    /**
     * 地图区块被点击的回调
     */

  }, {
    key: 'handleClick',
    value: function handleClick(d, e) {
      var _props = this.props,
          key = _props.key,
          onClick = _props.onClick;


      return onClick && onClick(this, d, key, e);
    }
  }, {
    key: 'handleMouseOver',
    value: function handleMouseOver(d, e) {
      var _props2 = this.props,
          key = _props2.key,
          hoverColor = _props2.hoverColor,
          hasDefaultColor = _props2.hasDefaultColor,
          onMouseOut = _props2.onMouseOut,
          onMouseOver = _props2.onMouseOver,
          onClick = _props2.onClick;


      if (!hasDefaultColor) {
        this.setState({
          fill: hoverColor
        });
      }

      return onMouseOver(this, d, key, e);
    }
  }, {
    key: 'handleMouseMove',
    value: function handleMouseMove(d, e) {
      var _props3 = this.props,
          key = _props3.key,
          onMouseMove = _props3.onMouseMove;


      return onMouseMove(this, d, key, e);
    }
  }, {
    key: 'handleMouseOut',
    value: function handleMouseOut(d, e) {
      var _props4 = this.props,
          key = _props4.key,
          color = _props4.color,
          onMouseOut = _props4.onMouseOut;


      this.setState({
        fill: color
      });

      return onMouseOut(this, d, key, e);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props5 = this.props,
          color = _props5.color,
          geoData = _props5.geoData,
          geoPath = _props5.geoPath;
      var fill = this.state.fill;


      return _react2.default.createElement('path', { d: geoPath(geoData),
        fill: fill,
        stroke: '#fff',
        strokeWidth: '1',
        onClick: this.handleClick.bind(this, geoData),
        onMouseOver: this.handleMouseOver.bind(this, geoData),
        onMouseMove: this.handleMouseMove.bind(this, geoData),
        onMouseOut: this.handleMouseOut.bind(this, geoData) });
    }
  }]);

  return Polygon;
}(_react.Component);

Polygon.propTypes = {
  color: _react.PropTypes.string,
  onClick: _react.PropTypes.func,
  onMouseOut: _react.PropTypes.func,
  onMouseMove: _react.PropTypes.func,
  onMouseOver: _react.PropTypes.func,
  geoData: _react.PropTypes.object,
  geoPath: _react.PropTypes.func
};
exports.default = Polygon;