"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _d = require('d3');

var _d2 = _interopRequireDefault(_d);

var _CommonProps = require('../CommonProps');

var _CommonProps2 = _interopRequireDefault(_CommonProps);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Svg = function (_Component) {
  _inherits(Svg, _Component);

  function Svg(props) {
    _classCallCheck(this, Svg);

    return _possibleConstructorReturn(this, (Svg.__proto__ || Object.getPrototypeOf(Svg)).call(this, props));
  }

  _createClass(Svg, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var _props = this.props,
          width = _props.width,
          height = _props.height,
          scaleExtent = _props.scaleExtent,
          projection = _props.projection,
          onZoom = _props.onZoom,
          onZoomStart = _props.onZoomStart,
          onZoomEnd = _props.onZoomEnd,
          center = _props.center;

      // implement zoom if xscale and y scale is set!

      if (projection && onZoom) {
        var newCenter = projection(center);

        var zoom = _d2.default.behavior.zoom().scale(projection.scale() * 2 * Math.PI).translate([width - newCenter[0], height - newCenter[1]]);

        if (scaleExtent) zoom.scaleExtent(scaleExtent);

        if (onZoom) zoom.on("zoom", function () {
          onZoom.call(_this2, zoom.scale(), zoom.translate());
        });

        if (onZoomStart) zoom.on("zoomstart", function () {
          onZoomStart.call(_this2, zoom.scale(), zoom.translate());
        });

        if (onZoomEnd) zoom.on("zoomend", function () {
          onZoomEnd.call(_this2, zoom.scale(), zoom.translate());
        });

        _d2.default.select(_reactDom2.default.findDOMNode(this.refs.svgContainer)).call(zoom);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          height = _props2.height,
          width = _props2.width,
          svgClassName = _props2.svgClassName,
          children = _props2.children;


      return _react2.default.createElement(
        'svg',
        {
          height: height,
          width: width,
          className: svgClassName,
          ref: 'svgContainer'
        },
        _react2.default.createElement(
          'g',
          null,
          children
        )
      );
    }
  }]);

  return Svg;
}(_react.Component);

Svg.propTypes = {
  width: _react.PropTypes.number,
  height: _react.PropTypes.number,
  svgClassName: _react.PropTypes.string
};
Svg.defaultProps = _extends({}, _CommonProps2.default, {
  svgClassName: 'remaps_container_svg',
  scaleExtent: [1 << 10, 1 << 28]
});
exports.default = Svg;